<?php

/*
* $Id: cm_ip_filter.php
* $Loc: /includes/modules/content/index_products/
*
* Name: Product_Filters-Attributes
* Version: 1.1
* Release Date: 05/22/2022
* Author: Kofod95
* 	 @kofod95
*
* License: Released under the GNU General Public License
*
* Comments: Copyright (c) 2021: Daniel - @Kofod95
* 
* 
*   Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
* 
*   1. Re-distributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
* 
*   2. Re-distributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
* 
*   3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
* 
*   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
* (Packaged with Zipur Bundler v2.0.2)
*/



  class cm_ip_filter extends abstract_executable_module {

    const CONFIG_KEY_BASE = 'MODULE_CONTENT_IP_FILTER_';

    function __construct() {
      parent::__construct(__FILE__);
    }

    function execute() {
      global $current_category_id, $languages_id;

      $content_width = MODULE_CONTENT_IP_FILTER_CONTENT_WIDTH;

      $products_attributes_array = array();
      //Find attributes in the current listing, so every filtering-option returns products
      //This query only works when in a category. Might be possible to allow filtering on a manufacturer-listing as well, and maybe even on advanced_search_results.php
      $products_options_name_query = $GLOBALS['db']->query("select distinct po.* 
                                                  from products_options po, products_attributes pa, products_to_categories p2c, products p 
		   									      where pa.products_id = p2c.products_id  and p.products_id = p2c.products_id 
											      and p.products_status = '1' and po.products_options_id = pa.options_id 
											      and p2c.categories_id = '" . (int)$current_category_id . "' and po.language_id = '" . (int)$languages_id . "' 
											      order by po.products_options_id");

	 if (!empty($products_options_name_query)) {	 
       while ($products_options_name = $products_options_name_query->fetch_assoc()) {
         $products_attributes_array[$products_options_name['products_options_id']] = ['options_id' => $products_options_name['products_options_id'],  
                                                                                      'options_name' => $products_options_name['products_options_name']];
																						
     foreach ($_GET as $key => $value) {
        if (preg_match('/attrib_/', $key)) {
			$matches[] = $value;  		
        }
      }
	  
	  //Check if filter is set, to remove those that will not return anything
	  if (!empty($matches)) {
        
		//Populate the array to use with the SQL IN-Statement
        foreach ($matches as $options_values_id) {
          $values_array[] = $options_values_id;
        }	

		$filter_data = implode("') AND pa.products_id IN (SELECT products_id FROM products_attributes WHERE options_values_id =  '", $values_array);

	       $products_options_query = $GLOBALS['db']->query("select distinct pov.* 
	                                              from products_options_values pov,  products_attributes pa, products_to_categories p2c, products p 
											      where pa.options_id = '" . (int)$products_options_name['products_options_id'] . "' 
											      and pa.options_values_id = pov.products_options_values_id and pa.products_id = p2c.products_id 
											      and p.products_id = p2c.products_id and p.products_status = '1' and p2c.categories_id = '" . (int)$current_category_id . "' 
											      and pov.language_id = '" . (int)$languages_id . "' 
												  AND pa.products_id IN (SELECT products_id FROM products_attributes WHERE options_values_id = '" . $filter_data . "')
											      order by products_options_values_id");

        } else {
          $products_options_query = $GLOBALS['db']->query("select distinct pov.* 
	                                              from products_options_values pov,  products_attributes pa, products_to_categories p2c, products p 
											      where pa.options_id = '" . (int)$products_options_name['products_options_id'] . "' 
											      and pa.options_values_id = pov.products_options_values_id and pa.products_id = p2c.products_id 
											      and p.products_id = p2c.products_id and p.products_status = '1' and p2c.categories_id = '" . (int)$current_category_id . "' 
											      and pov.language_id = '" . (int)$languages_id . "' 
											      order by products_options_values_id");
        }

          while ($products_options = $products_options_query->fetch_assoc()) {
            $products_attributes_array[$products_options_name['products_options_id']]['options_array'][] = $products_options;
          }
       }
	
	   $options = [];
       foreach ($products_attributes_array as $option_id => $attribute) {
         $option_choices = [];
		 $option_choices[] = ['id' => '', 'text' => $attribute['options_name']];

         if(isset($attribute['options_array'])) {
         foreach ($attribute['options_array'] as $value_id => $value) {
           $text = $value['products_options_values_name'];
           $option_choices[] = ['id' => $value['products_options_values_id'], 'text' => $text];
          }

          $options[] = [
                'id' => $option_id,
                'name' => $attribute['options_name'],
                'choices' => $option_choices,
                ];
         }
	   }
	
	//Return only if there are filters to show
       if(isset($options) && !empty($options)) {
    

        $tpl_data = [ 'group' => $this->group, 'file' => __FILE__ ];
        include 'includes/modules/content/cm_template.php';
	   }
     }
    }

    protected function get_parameters() {
      return [
        'MODULE_CONTENT_IP_FILTER_STATUS' => [
          'title' => 'Enable Filter Module',
          'value' => 'True',
          'desc' => 'Do you want to enable this module?',
          'set_func' => "Config::select_one(['True', 'False'], ",
        ],
        'MODULE_CONTENT_IP_FILTER_CONTENT_WIDTH' => [
          'title' => 'Content Width',
          'value' => '12',
          'desc' => 'What width container should the content be shown in? (12 = full width, 6 = half width).',
          'set_func' => "Config::select_one(['12', '11', '10', '9', '8', '7', '6', '5', '4', '3', '2', '1'], ",
        ],
        'MODULE_CONTENT_IP_FILTER_SORT_ORDER' => [
          'title' => 'Sort Order',
          'value' => '80',
          'desc' => 'Sort order of display. Lowest is displayed first.',
        ],
      ];
    }

  }
